package edu.toronto.cs.ctl;

/**
 ** This is an existential strong until CTL node.
 **/
public class CTLEUiNode extends CTLEUNode
{

  protected int bound;

  /**
   ** Construct a bounded existential strong until CTL node using two
   ** other nodes as its children.
   **/
  protected CTLEUiNode (CTLNode phi, int i, CTLNode psi)
  {
    super (phi, psi);
    bound = i;
  }

  /**
   ** Gets the bound on the EUi.
   **/
  public int getI ()
  {
    return bound;
  }

  /**
   ** Sets the bound on the EUi.
   **/
  protected void setI (int i)
  {
    bound = i;
  }

  public String toString ()
  {
    return "E[" + getLeft () + " U" + bound + " " + getRight () + "]";
  }


  public void accept (CTLVisitor v, Object s)
  {
    v.visitEUiNode (this, s);
  }


}
