package edu.toronto.cs.ctl;

import java.util.*;

/**
 ** This is a CTL Placeholder node.
 **/
public class CTLPlaceholderNode extends CTLAtomNode
{

  protected final Object [] props; // restricted to these propositions

  protected CTLPlaceholderNode ()
  {
    super ();
    props = null;
  }

  /**
   ** Construct a placeholder CTL node from an Object [].
   **/
  protected CTLPlaceholderNode (Object ph, Object [] proplist)
  {
    super (ph);
    props = proplist;
  }

  public Object [] getProps ()
  {
    return props;
  }

  public String toString ()
  {

    StringBuffer sb = new StringBuffer ();
    
    sb.append ('?');
    sb.append (getName ());
    sb.append ('{');

    // -- add all properties separated by comma
    for (Iterator it = Arrays.asList (getProps ()).iterator (); 
	 it.hasNext ();)
      {
	sb.append (it.next ());
	if (it.hasNext ()) sb.append (", ");
      }
    sb.append ('}');

    return sb.toString ();
  }
}
