package edu.toronto.cs.experiments;

import edu.toronto.cs.algebra.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.smv.*;
import edu.toronto.cs.mdd.*;
import edu.toronto.cs.util.*;

import java.util.*;
import java.io.*;


public class SMVBddModule extends SMVModule
{
  String bddFileName;
  
  public SMVBddModule (String[] _vars, String _bddFileName)
  {
    super ("main");
    varsNamed = _vars;
    bddFileName = _bddFileName;
  }

  public MvSet computeTrans ()
  {
    return DDUnDumper.readBDDSafe (ddManager, bddFileName);
  }
  
  public MvState initializeInitState (MvState initState)
  {
    // XXX This needs work
    return initState;
  }
  
  
  public static SMVModule initModule (String[] args)
  {
    /***
	args [0] -- lattice name
	args [1] -- prop ordering file
	args [2] -- bdd file
    ***/
    String latticeName = args [0];
    String propOrderFileName = args [1];
    String bddFileName = args [2];
    
    String[] vars = computeVars (propOrderFileName);
    SMVBddModule module = new SMVBddModule (vars, bddFileName);
    module.setLattice (Lattices.getLatticeByName (latticeName));
    return module;
  }
  

  // -- reads variables from a file
  static String[] computeVars (String fileName)
  {
    try 
      {
	List vars = new ArrayList ();
	BufferedReader in = new BufferedReader (new FileReader (fileName));
	String s;
	while ( (s = in.readLine ()) != null) 
	  vars.add (s);
	
	return (String[])vars.toArray (new String [vars.size ()]);
      }
    catch (IOException ex)
      {
	Assert.assert (ex);
      }
    return null;
  }
  
}
