package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import org.apache.log4j.*;

public class SparseFunction extends TableFunction {

    static Category log = 
	Category.getInstance("edu.toronto.cs.experiments.SparseFunction");

    static {
	BasicConfigurator.configure();
    }

    float sparsity;

    public SparseFunction(int m, int k, float sp) {
	super(m,k);
	sparsity = sp;
	fill();
    }

    protected void fill() {
	log.info("Filling");
	for (int i=0; i<table.length; i++) {
	    if (Chaos.nextThreshold(sparsity)) {
		int curr = 1+Chaos.nextUpTo(m-1);
		log.debug("Setting point "+i+" to "+curr);
		table[i] = curr;
	    }
	    else 
		table[i] = 0;
		
	}
    }

    public Function clone (int m_, int k_) {
	return new SparseFunction(m_, k_, sparsity);
    }

    public static void main(String argv[]) {
	Chaos.seed(23);
	Function fn = new SparseFunction(3,4, (float)0.1);
	Iterator zoobert = fn.getAllPoints();
	while (zoobert.hasNext()) {
	    zoobert.next();
	}
    }
}
