package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import org.apache.log4j.*;

public class SparseInputMVSkew extends SparseInputFunction {

    static Category log = 
	Category.getInstance("edu.toronto.cs.experiments.SparseInputMVSkew");

    static {
	BasicConfigurator.configure();
    }

    float skew;
    public SparseInputMVSkew(int m, int k, float sp, float dis, float skew_) {
	super(m,k, sp, dis);
	skew = skew_;
    }


    public Function clone (int m_, int k_) {
	return new SparseInputMVSkew(m_, k_, sparsity, disTheta, skew);
    }

    protected int fillRow(float disag) {
	// assume that disagreement is above threshold!
	if (Chaos.nextThreshold(sparsity))
	    {
		if (Chaos.nextThreshold(skew))
		    return (m-1); // true
		else {
		    // return some non-true, non-false value
		    int curr = 1+Chaos.nextUpTo(m-2);
		    return curr;
		}
	    }
	else return 0;
    }
    

    public static void main(String argv[]) {

	Function fn = new SparseInputMVSkew(3,4, (float)0.1, (float)0.25, (float)0.8);
	Iterator zoobert = fn.getAllPoints();
	while (zoobert.hasNext()) {
	    zoobert.next();
	}
    }
}
