package edu.toronto.cs.gui;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;


public class ColourCellEditor extends DefaultCellEditor implements TableCellEditor
{
  JColorChooser chooser;
  JDialog chooserDialog;

  boolean editingOngoing = false;

  public ColourCellEditor ()
  {
    // Unbelievable...
    super (new JCheckBox ());
    // And now:
    editorComponent = new JButton ();
    editorComponent.setOpaque (false);
    ((JButton)editorComponent).addActionListener (new ActionListener ()
			 {
			   public void actionPerformed 
			     (ActionEvent e)
			     {
			       System.err.println ("This is an e");
			       setEditing ();
			       recreateDialog ();
			       chooserDialog.show ();
			     }
			 }
			 );
    chooser = new JColorChooser (Color.black);

    setClickCountToStart (2); // So far as I can tell, this has little effect
  }

  protected void recreateDialog ()
  {
    chooserDialog = JColorChooser.createDialog 
				 (editorComponent, 
				  "Choose colour:", true,
				  chooser,
				  new ColourCellEditor.OkListener (this), 
				  new ColourCellEditor.CancelListener (this));  
  }
    

  public boolean stopCellEditing ()
  {
    return !editingOngoing;
  }
  
  public void setStopCellEditing ()
  {
    editingOngoing = false;
  }

  public void setEditing ()
  {
    editingOngoing = true;
  }
  
  public Object getCellEditorValue ()
  {
    return chooser.getColor ();
  }

  public boolean isCellEditable(EventObject anEvent)
  {
    return true;
  }

  public Component getTableCellEditorComponent 
    (JTable table, Object value, boolean hasFocus, 
     int row, int column) 
  {
    //    System.err.println ("Hi, we're trying to edit the table...");
    // XXX BIG hack, remove:
    // if (value instanceof String)
    //  return null;
    chooser.setColor ((Color)value);
    return editorComponent;
  }
  
  public class OkListener implements ActionListener
  {
    ColourCellEditor actor;
    protected OkListener (ColourCellEditor _actor)
    {
      actor = _actor;
    }
    
    public void actionPerformed (ActionEvent e)
    {
      actor.fireEditingStopped ();
    }
    
  }

  public class CancelListener implements ActionListener
  {
    ColourCellEditor actor;
    protected CancelListener (ColourCellEditor _actor)
    {
      actor = _actor;
    }
    
    public void actionPerformed (ActionEvent e)
    {
      actor.cancelCellEditing ();
    }
    
  }  

}




  

