
package edu.toronto.cs.gui;

import edu.toronto.cs.modelchecker.*;

import java.util.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;

/**
 * XCToolbar.java
 *
 * A toolbar for the model-checker GUI
 *
 * Created: Thu Jun 20 14:27:00 2002
 *
 * @author <a href="mailto:anya@tallinn.cs">Tafliovich Anya</a>
 * @version
 */

public class XCToolbar extends JToolBar {

  // the buttons
  JButton open; //XML, openBDD, openGeneric;
  JButton loadFairness, saveFairness, loadCTL, saveCTL;
  JButton lattice;
  JButton quit;

  /**
   ** Constructor:
   ** create a new toolbar, associate the actions defined in 'actionMap'
   ** with the buttons
   **/
  public XCToolbar (ActionMap actionMap){
    super();
    
//     openXML = new JButton ((Action)actionMap.get("Open XML model..."));
//     openXML.setText("XML");
//     //    openXML.setMnemonic (KeyEvent.VK_X);
    
//     openBDD = new JButton ((Action)actionMap.get("Open BDD model..."));
//     openBDD.setText("BDD");
//     //  openBDD.setMnemonic (KeyEvent.VK_B);

    open = new JButton ((Action)actionMap.get
			       ("Open a model..."));
    open.setText ("Model");
    //  openGeneric.setMnemonic (KeyEvent.VK_G);

    // fairness
    loadFairness =
      new JButton ((Action)actionMap.get ("Load fairness conditions"));
    loadFairness.setText("fairness");
    saveFairness =
      new JButton ((Action)actionMap.get ("Save fairness conditions"));
    saveFairness.setText("fairness");

    // CTL history buttons
    loadCTL = new JButton ((Action)actionMap.get ("Load CTL history"));
    loadCTL.setText("CTL");
    saveCTL = new JButton ((Action)actionMap.get ("Save CTL history"));
    saveCTL.setText("CTL");
    
    // lattice display
    lattice = new JButton ((Action)actionMap.get ("Lattice info"));
    lattice.setText("Lattice");

    quit = new JButton ((Action)actionMap.get("Quit"));
    quit.setText(null);
    //quit.setMnemonic (KeyEvent.VK_Q);

    //add (openXML);
    //add (openBDD);
    add (open);
    addSeparator ();
    add (loadFairness);
    add (saveFairness);
    add (loadCTL);
    add (saveCTL);
    addSeparator ();
    add (lattice);
    addSeparator ();
    add (quit);

    // turn off dragging
    setFloatable (false);
  }
  
}// XCToolbar
