package edu.toronto.cs.keg;

import java.util.*; // We all love java.util

import edu.toronto.cs.ctl.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;

import edu.toronto.cs.mvset.MvState;
import edu.toronto.cs.algebra.*;


public class KEGStateTransition extends DGEdge
{
  int transitionValue;
  
  public KEGStateTransition (DGNode origin, DGNode destination, int transition)
  {
    super (origin, destination);
    transitionValue = Algebra.NO_VALUE;
    setValue (transition);
  }

  public KEGStateTransition (DGNode origin, DGNode destination)
  {
    super (origin, destination);
    transitionValue = Algebra.NO_VALUE;
  }
  
  public int getValue ()
  {
    return transitionValue;
  }
  
  public void setValue (int v)
  {
    transitionValue = v;
  }

  public void accept (KegEdgeVisitor visitor, Object stateinfo)
  {
    visitor.visitKEGStateTransition (this, stateinfo);
  }
  
}












