package edu.toronto.cs.lift;

import java.util.*;


import edu.toronto.cs.smv.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.algebra.*;

public class Game extends SMVModule
{
  public static final int A = 0;
  public static final int B = 1;
  
  public Game ()
  {
    super ("game");
    vars = new String[]{"a", "b"};
  }
  
  public MvSet computeTrans ()
  {
    //return computeA ().ptwiseCompose (FiniteLattice.COMPOSE, computeB ());
    MvSet set = cur (A).not ().and (cur (B).not ());
    set = cur (A, bot).and (cur (B, bot));
    set = computeA ();
    System.out.println ("Dumping set to: /tmp/game.daVinci");
    set.writeToDaVinci ("/tmp/game.daVinci", ordering);
    return computeA ();
  }
  
  MvSet computeA ()
  {
    return cur (A, bot).and (cur (B, bot).
			     and (next (A, bot).and (next (B, bot)))).or
      (cur (A, bot).and (cur (B, bot).and (next (A).and (next (B))))).or
      (cur (A).and (cur (B).and (next (A).and (next (B)))));
    
  }
  
  MvSet computeB ()
  {
    return computeA ().or
      (cur (A).and (cur (B).and (next (A, bot).and (next (B, bot)))));
  }
  
  public MvState initializeInitState (MvState initState)
  {
    initState.setValue (getVarOrder (A), bot);
    initState.setValue (getVarOrder (B), bot);
    return initState;
  }
  
  public static SMVModule initModule (String[] args)
  {
    System.out.println ("initModule is called with args:");
    System.out.println (Arrays.asList (args));
    
    
    Game game;
    FiniteLattice lattice;
    
    try {
      System.out.println ("Intiailizing " + Game.class.getName ());
      game = new Game ();
      //lattice = LatticeFactory.parse ("play/gxl/9val-logic.xml");
      //lattice = LatticeFactory.parse ("play/gxl/boolean.xml");
      lattice = LatticeFactory.parse ("play/models/phone/4val-logic.xml");
    }
    catch (Exception ex) {
      throw new RuntimeException ("No lattice to be found");
    }

    lattice = new edu.toronto.cs.tlq.UpSetLattice (0);
    game.setLattice (lattice);
    return game;
  }
  
}
