package edu.toronto.cs.lift;

import java.util.*;


import edu.toronto.cs.smv.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.algebra.*;

public class TLQTest extends SMVModule
{
  public static final int A = 0;
  public static final int B = 1;
  
  public TLQTest ()
  {
    super ("");
    vars = new String[]{"a", "b"};
  }
  
  public MvSet computeTrans ()
  {

    // -- we have 5 transitions in our system, here we go
    MvSet set = 
      cur (A).and (cur (B)).and 
      (next (A, bot).and (next (B)).or 
       (next (A).and (next (B, bot)))).or
      
      (cur (A).and (cur (B, bot)).and 
       (next (A).and (next (B)).or 
	(next (A, bot).and (next (B)))).or

       (cur (A, bot).and (cur (B)).and 
	(next (A, bot).and (next (B)))));

    return set;
  }
  
  public MvState initializeInitState (MvState initState)
  {
    initState.setValue (getVarOrder (A), top);
    initState.setValue (getVarOrder (B), top);
    return initState;
  }
  
  public static SMVModule initModule (String[] args)
  {
    System.out.println ("initModule is called with args:");
    System.out.println (Arrays.asList (args));
    
    
    TLQTest game;
    FiniteLattice lattice;
    
    game = new TLQTest ();
    lattice = new edu.toronto.cs.tlq.UpSetLattice (0);
    game.setLattice (lattice);
    return game;
  }
  
}
