package edu.toronto.cs.xchek.utils;

/** Utility functions for the MDD package, particularly for
    building arbitrarily-nested arrays. */


public class ArbArray {
    
    Object[] da;
    int depth;
    int[] dims;

    /** Initialize an arbitary-depth array. 
	@param howdeep the depth of the array
	@param dim the array containing the array's dimensions
    */
    public ArbArray (int howdeep, int[] dim) {
	this(howdeep, dim, 0);
    };

    public ArbArray (int howdeep, int[] dim, Object def) {
	this(howdeep, dim, 0, def);
    };

    public ArbArray (int howdeep, int[] dim, int idx) {
	System.out.println("ArbArray called: depth="+howdeep+", index="+
			   idx);
	da = new Object[dim[idx]];
	depth = howdeep;
	dims = new int[howdeep];
	System.arraycopy(dim, idx, dims, 0, howdeep);
	
	if (depth > 1) // more nesting to do
	    {
		for (int i=0; i<dim[idx]; i++)
		    da[i] = new ArbArray(depth-1, dim, idx+1);
	    }
	
    };

    public ArbArray (int howdeep, int[] dim, int idx, Object def) {
	System.out.println("ArbArray called: depth="+howdeep+", index="+
			   idx);
	da = new Object[dim[idx]];
	depth = howdeep;
	dims = new int[howdeep];
	System.arraycopy(dim, idx, dims, 0, howdeep);
	
	if (depth > 1) // more nesting to do
	    {
		for (int i=0; i<dim[idx]; i++)
		    da[i] = new ArbArray(depth-1, dim, idx+1);
	    }
	else {
	    for (int i=0; i<dims[0]; i++)
		da[i]=def;
	}
    };

    public void setItemAt(int[] indices, Object obj)
    {
	setItemAtRecur(indices, obj, 0);
    };

    public Object getItemAt(int[] indices)
    {
	return getItemAtRecur(indices, 0);
    };

    void setItemAtRecur(int[] indices, Object obj, int howfar)
    {
	if (depth == 1) {
	    System.out.println("Setting item.");
	    da[indices[howfar]]=obj;
	}
	else {
	    System.out.println("setItem: howfar="+howfar+", index="+indices[howfar]);
	    ((ArbArray)da[indices[howfar]]).setItemAtRecur(indices, obj, howfar+1);}
    }

    Object getItemAtRecur(int[] indices, int howfar)
    {
	if (depth == 1) {
	    System.out.println("Getting item.");
	    return da[indices[howfar]];
	}
	else {
	    System.out.println("getItem: howfar="+howfar+", index="+indices[howfar]);
	    return ((ArbArray)da[indices[howfar]]).getItemAtRecur(indices, howfar+1);}
    }


};
