package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.mvset.MvState;

import java.awt.Color;

public class Dv
{

  static String [] ARROWS = { "",
		       "arrow",
		       "circle",
		       "farrow",
		       "fcircle" 
  };

  static public StringBuffer item (String name, StringBuffer body)
  {
    StringBuffer result = new StringBuffer ();
    result.append ("l(");
    result.append (StringUtil.quote (name));
    result.append (',');
    result.append (body);
    result.append (")");
    return result;
  }

  static public StringBuffer translateColour (Object colour)
  {
    StringBuffer sb = new StringBuffer ();
    
    if (colour instanceof Color)
      {
	sb.append ('#');
	sb.append
	  (pad (2, Integer.toHexString(((Color)colour).getRed ()), '0'));
	sb.append
	  (pad (2, Integer.toHexString(((Color)colour).getGreen ()), '0'));
	sb.append
	  (pad (2, Integer.toHexString(((Color)colour).getBlue ()), '0'));
	return sb;
      }
    
    // Default case  
    sb.append (colour.toString ());
    return sb;
      
  }

  static public StringBuffer pad (int length, String s, char character)
  {
    StringBuffer sb = new StringBuffer ();
    sb.append (s);
    if (s.length () >= length)
      return sb;
    
    for (int i = 0; i < (length - s.length ()); i++)
      {
	sb.insert (0, character);
      }
    return sb;
  } 
  
  static public StringBuffer nodebody  
    (String type, StringBuffer attr, StringBuffer edges)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('n');
    result.append ( Dv.body (type, attr, edges));
    return result;
  }
  
  static public StringBuffer body (String type, StringBuffer attr, StringBuffer s)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('(');
    result.append (StringUtil.quote (type));
    result.append (',');
    result.append (attr);
    result.append (',');
    result.append (s);
    result.append (')');
    return result;
  }
  
  static public StringBuffer enum (Collection strings)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('[');
    for (Iterator it = strings.iterator (); it.hasNext ();)
    {
      result.append ((StringBuffer)it.next ());
      if (it.hasNext ())
	{
	  result.append (',');
	}
    }
    result.append (']');
    return result;
  }
      
  static public StringBuffer attrib (String attribname, String attrib)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('a');
    result.append ('(');
    result.append (StringUtil.quote(attribname));
    result.append (',');
    result.append (StringUtil.quote(attrib));
    result.append (')');
    return result;
  }

 
  static public StringBuffer attrib (String attribname, StringBuffer attrib)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('a');
    result.append ('(');
    result.append (StringUtil.quote(attribname));
    result.append (',');
    result.append (StringUtil.quote(attrib));
    result.append (')');
    return result;
  }
  
  static public StringBuffer edgebody (String typestr, StringBuffer attr, 
				       StringBuffer ref)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('e');
    result.append (Dv.body (typestr, attr, ref));
    return result;
  }

  static public StringBuffer ref (String nodename)
  {
    StringBuffer result = new StringBuffer ();
    result.append ('r');
    result.append ('(');
    result.append (StringUtil.quote(nodename));
    result.append (')');
    return result;
  }
}











