package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.mdd.*;
import edu.toronto.cs.algebra.*;


public class PrettyMDDColouringStrategy extends PrettyColouringStrategy
{
  static Logger log = new Logger ("PrettyMDDColouringStrategy");
  

  PrettyMDDEdgeColouring edger;
  PropOrderIf prop;
  Map colourmap;
  Algebra lattice;
  
  public PrettyMDDColouringStrategy (PropOrderIf _prop, 
				     Map _colourmap, Algebra _lat, 
				     PrettyMDDEdgeColouring _edger)
  {
    edger = _edger;
    prop = _prop;
    edger = _edger;
    lattice = _lat;
  }
  
  public void visitPrettyGraphMDDNode (PrettyGraphMDDNode node)
  {
    log.debug ("Visiting "+node);
    
      MDDNode mnode = (MDDNode) node.getMDD ();
      if (!mnode.isConstant ())
	{
	  String propName = prop.getPropName (mnode.getVarIndex ());
	  if (prop.isPostImage (mnode.getVarIndex ()))
	    propName += "\'";
	  node.setLabel (propName);
	}
      
      else
	node.setLabel 
	  (""+lattice.getElementKeyByIdx (mnode.getValue ()));
      for (Iterator it = node.getAllEdges ().iterator (); 
	   it.hasNext ();)
	{
	  edger.visit ((DGEdge)it.next (), null);
	}    
  }

}








