package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;
import edu.toronto.cs.mvset.MvState;

// Sadly necessary:
import edu.toronto.cs.modelchecker.*;

public class PrettySimpleStateLabelStrategy 
  implements PrettyStateLabelStrategy
{
  
  String standardBanner = "";
  String standardFooter = "";
  PropOrderIf props;
  
  public PrettySimpleStateLabelStrategy (PropOrderIf _props)
  {
    props = _props;
  }

  protected String getBanner (KEGStateNode node, Object stateinfo)
  {
    if (((List)stateinfo).size () == 0)
      return "Initial state.";
    return standardBanner;
  }

  protected String getFooter (KEGStateNode node, Object stateinfo)
  {
    return standardFooter;
  }

  public PrettyStateLabelStrategy setBanner (String b)
  {
    standardBanner = b;
    return this;
  }
  
  public PrettyStateLabelStrategy setFooter (String f)
  {
    standardFooter = f;
    return this;
  }
  
  public Object getLabel (KEGStateNode node, Object stateinfo)
  {
    return new PrettyBaseKegLabel (props, node.getState ())
      .setBanner (getBanner (node, stateinfo))
      .setFooter (getFooter (node, stateinfo))
      .addToDesired (getInterestingProps (node, stateinfo));
  }

  protected Set getInterestingProps (KEGStateNode node, Object stateinfo)
  {
    Set interesting = new HashSet ();
    List parents = (List) stateinfo;
    if (parents.size () == 0)
      {
	// Root node. Add everything.
	for (int i = 0; i < node.getState ().numUPP (props); i++)
	    interesting.add (new Integer (i));
	
	return interesting;
      }

    List ancestry = (List) stateinfo;
    //int i;
    //int j = 1;
    PrettyKegGraphNode knode = null;
    //System.out.println ("Dealing with node: "+ctl);
    //System.out.println ("Ancestry size: "+ancestry.size ());
    for (int i = ancestry.size (); i > 0; i--)
      {
	//System.out.println ("   On node: "+ancestry.get (i-1));
	if (((PrettyKegGraphNode)ancestry.get (i-1)).getKegNode () instanceof KEGStateNode)
	  {
	    knode = (PrettyKegGraphNode) ancestry.get (i-1);
	    break;
	  }
      }
    Assert.assert (knode != null);
	
    MvState parentMv = ((KEGStateNode)knode.getKegNode ()).getState ();
    MvState childMv = node.getState ();
    // XXX Everything below is a hack on MvState...
    for (int i = 0; i < parentMv.numUPP (props); i++)
      {
	if (parentMv.getVarRestriction (i, props) 
	    != childMv.getVarRestriction (i, props))
	  {
	    interesting.add (new Integer (i));
	  }
      }
    return interesting;
  }
}

  
    






