package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.mvset.MvState;


public class PrettyXKColourer extends PrettyColouringStrategy
{
  public static Object STATE_COLOUR = 
    PrettyKegColouringStrategy.STATE_COLOUR;
  public static String STATE_FONTSTYLE = 
    PrettyKegColouringStrategy.STATE_FONTSTYLE;
  public static String STATE_FONTFAMILY = 
    PrettyKegColouringStrategy.STATE_FONTFAMILY;
  public static boolean STATE_HIDTOSTART = 
    PrettyKegColouringStrategy.STATE_HIDTOSTART;
  public static int STATE_BORDERLINENUM = 
    PrettyKegColouringStrategy.STATE_BORDERLINENUM;
  public static int STATE_BORDERLINESOLIDITY = 
    PrettyKegColouringStrategy.STATE_BORDERLINESOLIDITY;
  public static String STATE_GRAPHIC = 
    PrettyKegColouringStrategy.STATE_GRAPHIC;

  PrettyGraphXKEdger edger;

  public PrettyXKColourer (PrettyGraphXKEdger _edger)
  {
    edger = _edger;
  }
  
  public void visit (DGNode node, Object stateinfo)
  {
    node.accept (this, stateinfo);
  }
  
  public void visitPrettyXKNode (PrettyGraphXKNode node, Object stateinfo)
  {
    // Now the fun bit...
    XKripke.XKripkeState xknode = node.getXK ();  
    node.setLabel (xknode.toString ())
      .setColour (STATE_COLOUR)
      .setFontStyle (STATE_FONTSTYLE)
      .setFontFamily (STATE_FONTFAMILY)
      .setHiddenToStart (STATE_HIDTOSTART)
      .setLineNum (STATE_BORDERLINENUM)
      .setLineSolidity (STATE_BORDERLINESOLIDITY)
      .setGraphicName (STATE_GRAPHIC);

    if (xknode.isInitial ())
	node.setLineNum (0).setLineThickness (PrettyConstants.THICK_LINE);
      
    if (node.getAllEdges () != null)
      for (Iterator it = node.getAllEdges ().iterator (); it.hasNext ();)
	edger.visit ((DGEdge)it.next (), null);
  }
}

  









