package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...
import edu.toronto.cs.util.*;

public class DGBreadthTraverse
{
  static Logger log = new Logger ("DGBreadthTraverser");

  List nodes;
  
  List queueOfNodes;

  DGraphVisitor visitor;

  public static Iterator getIterator (DGNode dg)
  {
    DGBreadthTraverse dt = new DGBreadthTraverse (dg, null);
    return dt.iterator ();
  }
  
  public static Iterator getIterator (DGraph dg)
  {
    DGBreadthTraverse dt = new DGBreadthTraverse (dg, null);
    return dt.iterator ();
  }

  private DGBreadthTraverse (DGNode xk, DGraphVisitor _visitor)
  {
    visitor = _visitor;
    nodes = new ArrayList ();
    queueOfNodes = new LinkedList ();
    queueOfNodes.add (xk);
    traverse ();
  }

  private DGBreadthTraverse (DGraph xk, DGraphVisitor _visitor)
  {
    visitor = _visitor;
    nodes = new ArrayList ();
    for (Iterator it = xk.getRootNodes ().iterator (); it.hasNext ();)
      {
	DGNode next = (DGNode) it.next ();
	queueOfNodes.add(next);
      }
    traverse ();
  }

  private void traverse ()
  {
    if (queueOfNodes.size () == 0)
      return;
    DGNode next = (DGNode) queueOfNodes.get (0);
    nodes.add (next);
    doNode (next);
    for (Iterator it = next.getSuccessors ().iterator (); it.hasNext ();)
      {
	queueOfNodes.add (it.next ());
      }
    traverse ();
    // Good grief! I went to sleep, and in the morning I woke up and was a LISP programmer...
  }
  
  private void doNode (DGNode node)
  {
    if (visitor != null)
      visitor.visit (node, null);
  }

  public Iterator iterator ()
  {
    log.debug ("DGDT: Iterator: "+nodes);
    return nodes.iterator ();
  }
  
}


