package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...
import edu.toronto.cs.util.*;


public class DGDoubleDepthTraverse extends DGSinglePass
{
  static Logger log = new Logger ("DGDoubleDepthTraverse");
  DGStateInfoSource historian;

  static public DGraphVisitor traverseWith 
    (DGraph graph, DGStateInfoSource visitor)
  {
    DGDoubleDepthTraverse dhp = new DGDoubleDepthTraverse (visitor);
    dhp.traverse (graph);
    return dhp.getVisitor ();
  }
  
  public DGDoubleDepthTraverse (DGraphVisitor visitor)
  {
    super (visitor);
    historian = new DGHistorian ();
  }

  public DGDoubleDepthTraverse (DGraphVisitor visitor, DGStateInfoSource _historian)
  {
    super (visitor);
    historian = _historian;
  }

  public void traverse (DGraph graph)
  {
    log.debug ("Pass one.");
    DGSinglePass.traverseWith (graph, historian);
    log.debug ("Pass two:");
    super.traverse (graph);
  }
  
  protected void applyVisitor (DGNode nnode)
  {
    log.debug ("YES I AM BEING RUN.");
    visitor.visit (nnode, historian.getStateInfo (nnode));
  }
 
}

  
