package edu.toronto.cs.xkripke;

import java.util.*;
import java.io.*;
import edu.toronto.cs.xkripke.XKripke.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.prettygraph.*;


/*** 
 *** Convers a Kripke structure to daVinci format
 ***/
public class XKripkeToDaVinci
{
  Map nodes;
  
  XKripke kripke;
  
  static Map colorMap;

  static 
  {
        // -- XXX Shameless hack
    colorMap = new HashMap ();
    colorMap.put ("T", "black");
    colorMap.put ("M", "blue");
    colorMap.put ("S", "green");
    colorMap.put ("DN", "orange");
    colorMap.put ("DK", "orange");
    colorMap.put ("DC", "red");
    colorMap.put ("SN", "purple");
    colorMap.put ("F", "white");
  }
  
  
  public static Map getColorMap ()
  {
    //return colorMap;
    return PrettyConstants.singletonMap;
  }

  public void saveToFile (StringBuffer sb, String filename)
  {
    try 
      {
	FileWriter daVinciFile;
	daVinciFile = new FileWriter (filename);
	daVinciFile.write (StringUtil.doEscapes(sb.toString ()));
	daVinciFile.close ();
      }
    catch (Exception e)
      {
	Assert.assert (e);
      }
  }
  
  public String getFileNameFrom (InputStream source)
  {
    try 
      {
      // -- prepare to read from stdin
      BufferedReader in = 
	new BufferedReader (new InputStreamReader (source));
      String str = in.readLine ();
      return str;
      }
    catch (Exception e)
      {
	Assert.assert (e);
      }
    return "";
  }

  public static void main (String [] args)
  {
    try
      {
	XKripkeToDaVinci xkc = 
	  new XKripkeToDaVinci (XKripkeFactory.parse (args [0]));
	xkc.run ();
      }
    catch (Exception e)
      {
	Assert.assert (e);
      }
  }

  XKripke xk;
  
  public XKripkeToDaVinci (XKripke _xk)
  {
    xk = _xk;
  } 
  
  public void run ()
  {
    System.out.println ("Please enter filename");
    run (getFileNameFrom (System.in));
  }

  public void run (String filename)
  {
   try 
      {
	DGraph pg = PrettyGraphXKVisitor.getPrettyXKGraph 
	  (xk, getColorMap ());
	DVGenNodeVisitor dvg = 
	  new DVGenNodeVisitor (new DVGenEdgeVisitor ());
	for (Iterator it = DGDepthTraverse.getIterator (pg); it.hasNext ();)
	  {
	    dvg.visit ((DGNode)it.next (), null);
	  }
	StringBuffer modeldv = dvg.getSB ();
	saveToFile (modeldv, filename);
      }
    catch (Exception e)
      {
	Assert.assert (e);
      } 
  }
  
}

